cd('scripts/')
%% Compiling PCA lines into a matrix
fpca = [];cnt = 1;mchKey = [];flyNum = [];
load('MCHOCT_amwControl_pcaF')
%% Compiling PCA lines into a matrix
for i = 1:length(finalStorage)
    for k = 1:length(finalStorage{i,4})
        fpca(cnt,:) = finalStorage{i,4}{2,k};
        cnt = cnt+1;
    end
end
%% Remove glomeruli
reUp = [];
glomsToInclude= [1:6,8:14,16];
for i = 0:16:length(fpca(1,:))-15
    temp = fpca(:,i+glomsToInclude);
    reUp(:,end+1:end+length(temp(1,:))) = temp;
end
fpca = reUp;

%% Replacing NaNs with mean values
tempF = [];
gloms = nanmean(fpca);
for i = 1:length(fpca(:,1))
    temp = find(isnan(fpca(i,:)));
    tempF(i,:) = fpca(i,:);
    for k = temp
        tempF(i,k) = gloms(k);
    end
end
fpca = tempF;
%% Z-score by glomerulus
pcaT = [];
glmLgth = length(glomsToInclude);
for i = 1:glmLgth
    glomTemp = i;
    glomTemp2 = fpca(:,glomTemp);
    glomMean = nanmean(glomTemp2(:));
    glomStd = nanstd(glomTemp2(:));
    pcaT(:,i) = (glomTemp2-glomMean)./glomStd;
end
fpca = pcaT;

[coeff,score,latent,tsquared,explained,mu] = pca(fpca);
%% Generate control animals
amwF = [];
for i = 1:length(flyNum)
    amwF(i) = amw(flyNum(i));
end
controlOut = score(~amwF,:);
flyNumC = flyNum(~amwF);
mchKeyC = mchKey(~amwF);

amwF = logical(amwF);
amwOut = score(amwF,:);
flyNumA = flyNum(amwF);
mchKeyA = mchKey(amwF);
%% Generate list of control flys without repeating a number
listFlyNum = cell(1,max(flyNumC));
for i = 1:length(flyNumC)
    if mchKeyC(i)
        continue
    end
    listFlyNum{flyNumC(i)} = [listFlyNum{flyNumC(i)};controlOut(i,:)];
end

listFlyNum2 = cell(1,max(flyNumA));
for i = 1:length(flyNumA)
    if mchKeyA(i)
        continue
    end
    listFlyNum2{flyNumA(i)} = [listFlyNum2{flyNumA(i)};amwOut(i,:)];
end
%%
pcaColorStore = [];
figTime = figure;
cnt = 1;
for i = 1:length(listFlyNum)
    if isempty(listFlyNum{i})
        continue
    end
    c3 = 300;
    a2 = scatter(listFlyNum{i}(1,1),listFlyNum{i}(1,2));hold on;
    pcaColorStore(cnt,:) = [0.25,0.25,0.6+rand(1)*0.4];
    pcaColorStore(cnt,:)= [0.1000    0.1000    0.5500];
    a2.MarkerFaceColor = pcaColorStore(cnt,:);
    a2.MarkerEdgeColor = [0 0 0];
    a2.MarkerFaceAlpha = 0.5;
    a2.SizeData = c3;
    cnt = cnt+1;
end
flyName = {};
for i = 1:cnt-1
    flyName{i} = strcat({'fly '},num2str(i));
    flyName{i} = flyName{i}{1};
end
atLeg = legend(flyName);
atLeg.Box = 'off';
atLeg.AutoUpdate = 'off';
%%
pcaColorStore2 = [];
cntA = 1;
for i = 1:length(listFlyNum2)
    if isempty(listFlyNum2{i})
        continue
    end
    c3 = 300;
    a2 = scatter(listFlyNum2{i}(1,1),listFlyNum2{i}(1,2));hold on;
    pcaColorStore2(cntA,:) = [0.6+rand(1)*0.4,0.25,0.25];
    pcaColorStore2(cntA,:) = [0.8000    0.1000    0.1000];
    a2.MarkerFaceColor = pcaColorStore2(cntA,:);
    a2.MarkerEdgeColor = [0 0 0];
    a2.MarkerFaceAlpha = 0.5;
    a2.SizeData = c3;
    cntA = cntA+1;
end
%%
flyName2 = {};
for i = 1:cntA-1
    flyName2{i} = strcat({'fly '},num2str(i+cnt-1),{' +amw'});
    flyName2{i} = flyName2{i}{1};
end
atLeg = legend([flyName,flyName2]);
atLeg.Box = 'off';
atLeg.AutoUpdate = 'off';
%%
cnt = 1;
for i = 1:length(listFlyNum)
    if isempty(listFlyNum{i})
        continue
    end
    c3 = 300;
    a2 = scatter(listFlyNum{i}(2:end,1),listFlyNum{i}(2:end,2));hold on;
    a2.MarkerFaceColor = pcaColorStore(cnt,:);
    a2.MarkerEdgeColor = [0 0 0];
    a2.MarkerFaceAlpha = 0.5;
    a2.SizeData = c3;
    temp = listFlyNum{i};
    %for ii = 1:length(temp(:,1))
    fillP1 = [];
    fillP2 = [];
    for iii = 1:length(temp(:,1))
        %if ii ~= iii
        %a3 = plot([temp(ii,1),temp(iii,1)],[temp(ii,2),temp(iii,2)]);
        %a3.LineWidth = 2;a3.Color = pcaColorStore(cnt,:);
        fillP1(end+1) = [temp(iii,1)];
        fillP2(end+1) = [temp(iii,2)];
        %end
    end
    
    if ~isempty(fillP1)
        if length(fillP1(:,1)) == 2;
            b1 = patch(fillP1,fillP2,[0.1000    0.1000    0.5500]);
        else
        c1 = sort(fillP1);ind = [];for iiii = 1:length(c1);ind(end+1) = find(c1(iiii) == fillP1);end
        
        fillP1 = fillP1(ind);fillP2 = fillP2(ind);
        b1 = patch(fillP1,fillP2,[0.1000    0.1000    0.5500]);
        b1.FaceAlpha = [0.5];
        b1.LineStyle = 'none';
        end
    end
    %end
    cnt = cnt+1;
end
%%
cnt = 1;
for i = 1:length(listFlyNum2)
    if isempty(listFlyNum2{i})
        continue
    end
    c3 = 300;
    a2 = scatter(listFlyNum2{i}(2:end,1),listFlyNum2{i}(2:end,2));hold on;
    a2.MarkerFaceColor = pcaColorStore2(cnt,:);
    a2.MarkerEdgeColor = [0 0 0];
    a2.MarkerFaceAlpha = 0.5;
    a2.SizeData = c3;
    temp = listFlyNum2{i};
    %for ii = 1:length(temp(:,1))
    fillP1 = [];
    fillP2 = [];
    for iii = 1:length(temp(:,1))
        %             if ii ~= iii
        %a3 = plot([temp(ii,1),temp(iii,1)],[temp(ii,2),temp(iii,2)]);
        %a3.LineWidth = 2;a3.Color = pcaColorStore(cnt,:);
        fillP1(end+1) = [temp(iii,1)];
        fillP2(end+1) = [temp(iii,2)];
        %           end
    end
    if ~isempty(b1)      
        c1 = sort(fillP1);ind = [];for iiii = 1:length(c1);ind(end+1) = find(c1(iiii) == fillP1);end
        fillP1 = fillP1(ind);fillP2 = fillP2(ind);
        
    end
    if length(fillP1(:,1)) == 2;
        b1 = patch(fillP1,fillP2,[0.8000    0.1000    0.1000]);
    else
            b1 = fill(fillP1,fillP2,[0.8000    0.1000    0.1000]);
        b1.LineStyle = 'none';
        b1.FaceAlpha = [0.5];
        end
    cnt = cnt+1;
end
%%
benFigureFormat_gen
pcaPercent = latent/sum(latent)*100;
a = xlabel(strcat('PCA 1','(',num2str(round(pcaPercent(1),2)),'%',')'));a.Position(2) = a.Position(2)-0.15;
a = ylabel(strcat('PCA 2','(',num2str(round(pcaPercent(2)),2),'%',')'));a.Position(1) = a.Position(1)-0.15;

cntA = 1;
cntC = 1;
MCHOCTiflyControl={};MCHOCTiflyAmw = {};
MCHOCTiflyControl{1,1} = 'FlyID';MCHOCTiflyControl{1,2} = 'OCT';MCHOCTiflyControl{1,3} = 'MCH';
MCHOCTiflyAmw{1,1} = 'FlyID';MCHOCTiflyAmw{1,2} = 'OCT';MCHOCTiflyAmw{1,3} = 'MCH';
for ii = 1:length(listFlyNum)
    if ~isempty(listFlyNum{ii})
        cntFly(cntC).OCT = listFlyNum{ii};
        MCHOCTiflyControl{cntC+1,2} = listFlyNum{ii};
        cntC = cntC+1;
    end
end
for ii = 1:length(listFlyNum2)
    if ~isempty(listFlyNum2{ii})
        amwFly(cntA).OCT = listFlyNum2{ii};
        MCHOCTiflyAmw{cntA+1,2} = listFlyNum2{ii};
        cntA = cntA+1;
    end
end
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% Generate list of control flys without repeating a number
listFlyNum = cell(1,max(flyNumC));
for i = 1:length(flyNumC)
    if ~mchKeyC(i)
        continue
    end
    listFlyNum{flyNumC(i)} = [listFlyNum{flyNumC(i)};controlOut(i,:)];
end

listFlyNum2 = cell(1,max(flyNumA));
for i = 1:length(flyNumA)
    if ~mchKeyA(i)
        continue
    end
    listFlyNum2{flyNumA(i)} = [listFlyNum2{flyNumA(i)};amwOut(i,:)];
end
%%
pcaColorStore = [];
figTime = figure;
cnt = 1;
for i = 1:length(listFlyNum)
    if isempty(listFlyNum{i})
        continue
    end
    c3 = 300;
    a2 = scatter(listFlyNum{i}(1,1),listFlyNum{i}(1,2));hold on;
    pcaColorStore(cnt,:) = [0.25,0.25,0.6+rand(1)*0.4];
    pcaColorStore(cnt,:) = [0.1000    0.1000    0.5500];
    a2.MarkerFaceColor = pcaColorStore(cnt,:);
    a2.MarkerEdgeColor = [0 0 0];
    a2.MarkerFaceAlpha = 0.5;
    a2.SizeData = c3;
    cnt = cnt+1;
end
flyName = {};
for i = 1:cnt-1
    flyName{i} = strcat({'fly '},num2str(i));
    flyName{i} = flyName{i}{1};
end
atLeg = legend(flyName);
atLeg.Box = 'off';
atLeg.AutoUpdate = 'off';
%%
pcaColorStore2 = [];
cntA = 1;
for i = 1:length(listFlyNum2)
    if isempty(listFlyNum2{i})
        continue
    end
    c3 = 300;
    a2 = scatter(listFlyNum2{i}(1,1),listFlyNum2{i}(1,2));hold on;
    pcaColorStore2(cntA,:) = [0.6+rand(1)*0.4,0.25,0.25];
    pcaColorStore2(cntA,:) =[0.8000    0.1000    0.1000];
    a2.MarkerFaceColor = pcaColorStore2(cntA,:);
    a2.MarkerEdgeColor = [0 0 0];
    a2.MarkerFaceAlpha = 0.5;
    a2.SizeData = c3;
    cntA = cntA+1;
end
%%
flyName2 = {};
for i = 1:cntA-1
    flyName2{i} = strcat({'fly '},num2str(i+cnt-1),{' +amw'});
    flyName2{i} = flyName2{i}{1};
end
atLeg = legend([flyName,flyName2]);
atLeg.Box = 'off';
atLeg.AutoUpdate = 'off';
%%
cnt = 1;
for i = 1:length(listFlyNum)
    if isempty(listFlyNum{i})
        continue
    end
    c3 = 300;
    a2 = scatter(listFlyNum{i}(2:end,1),listFlyNum{i}(2:end,2));hold on;
    a2.MarkerFaceColor = pcaColorStore(cnt,:);
    a2.MarkerEdgeColor = [0 0 0];
    a2.MarkerFaceAlpha = 0.5;
    a2.SizeData = c3;
    temp = listFlyNum{i};
    fillP1 = [];
    fillP2 = [];
    for iii = 1:length(temp(:,1))
        fillP1(end+1) = [temp(iii,1)];
        fillP2(end+1) = [temp(iii,2)];
    end
    if ~isempty(b1)
        
        c1 = sort(fillP1);ind = [];for iiii = 1:length(c1);ind(end+1) = find(c1(iiii) == fillP1);end
        fillP1 = fillP1(ind);fillP2 = fillP2(ind);
        
        if length(temp(:,1)) == 2
            b1 = patch(fillP1,fillP2,[0.1000    0.1000    0.5500]);
            b1.FaceAlpha = [0.5];
        else
        b1 = patch(fillP1,fillP2,[0.1000    0.1000    0.5500]);
        b1.FaceAlpha = [0.5];
        b1.LineStyle = 'none';
        end
    end
    cnt = cnt+1;
end
%%
cnt = 1;
for i = 1:length(listFlyNum2)
    if isempty(listFlyNum2{i})
        continue
    end
    c3 = 300;
    a2 = scatter(listFlyNum2{i}(2:end,1),listFlyNum2{i}(2:end,2));hold on;
    a2.MarkerFaceColor = pcaColorStore2(cnt,:);
    a2.MarkerEdgeColor = [0 0 0];
    a2.MarkerFaceAlpha = 0.5;
    a2.SizeData = c3;
    temp = listFlyNum2{i};
        fillP1 = [];
    fillP2 = [];
    for iii = 1:length(temp(:,1))

        fillP1(end+1) = [temp(iii,1)];
        fillP2(end+1) = [temp(iii,2)];
    end
    if ~isempty(b1) 
        c1 = sort(fillP1);ind = [];for iiii = 1:length(c1);ind(end+1) = find(c1(iiii) == fillP1);end
        fillP1 = fillP1(ind);fillP2 = fillP2(ind);
        if length(fillP1(:,1)) == 2;
            b1 = patch(fillP1,fillP2,[0.8000    0.1000    0.1000]);
            b1.FaceAlpha = [0.5];
        else
        b1 = patch(fillP1,fillP2,[0.8000    0.1000    0.1000]);
            b1.FaceAlpha = [0.5];
        b1.LineStyle = 'none';
        end
    end
    cnt = cnt+1;
end
%%
benFigureFormat_gen
pcaPercent = latent/sum(latent)*100;
a = xlabel(strcat('PCA 1','(',num2str(round(pcaPercent(1),2)),'%',')'));a.Position(2) = a.Position(2)-0.15;
a = ylabel(strcat('PCA 2','(',num2str(round(pcaPercent(2)),2),'%',')'));a.Position(1) = a.Position(1)-0.15;
%save('~/Desktop/makeFigures/toUpload/Fig4fColorGuide','pcaColorStore','pcaColorStore2')
pause(0.5)
%saveas(gcf,'~/Desktop/makeFigures/toUpload/Fig4h_MCHpcaScatterAMW','pdf')
%%
MCHOCTiflyAmw{1,4} = 'I.D.';
MCHOCTiflyControl{1,4} = 'I.D.';
cntA = 1;
cntC = 1;
for ii = 1:length(listFlyNum2)
    if ~isempty(listFlyNum2{ii})
        amwFly(cntA).MCH = listFlyNum2{ii};
        MCHOCTiflyAmw{cntA+1,3} = listFlyNum2{ii};
        MCHOCTiflyAmw{cntA+1,4} = finalStorage{ii,5};
        cntA = cntA+1;
    end
end
for ii = 1:length(listFlyNum)
    if ~isempty(listFlyNum{ii})
        
        cntFly(cntC).MCH = listFlyNum{ii};
        MCHOCTiflyControl{cntC+1,3} = listFlyNum{ii};
        MCHOCTiflyControl{cntC+1,4} = finalStorage{ii,5};

        cntC = cntC+1;
    end
end

%%
for i = 1:length(MCHOCTiflyAmw(:,1))-1
    tempName = strcat({'fly '},num2str(i+8));tempName = tempName{1};
    MCHOCTiflyAmw{i+1,1} = tempName;
end
for i = 1:length(MCHOCTiflyControl(:,1))-1
    tempName = strcat({'fly '},num2str(i));tempName = tempName{1};
    MCHOCTiflyControl{i+1,1} = tempName;
end

benDistCalc_fig4f_gen




